var __create = Object.create;
var __defProp = Object.defineProperty;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __export = (target, all2) => {
  for (var name in all2)
    __defProp(target, name, {get: all2[name], enumerable: true});
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? {get: () => module2.default, enumerable: true} : {value: module2, enumerable: true})), module2);
};
__markAsModule(exports);
__export(exports, {
  all: () => all,
  allSettled: () => allSettled,
  any: () => any,
  race: () => race
});
var import_conclude = __toModule(require("./conclude"));
var import_effects = __toModule(require("./effects"));
const noop = () => {
};
const returnResults = (_, results, callback) => callback(null, results);
const throwErrors = (errors, _, callback) => callback(errors);
const afterOne = {
  all: (error, result) => ({error, result, stop: error}),
  any: (error, result) => ({error, result, stop: !error}),
  race: (error, result) => ({error, result, stop: true}),
  allSettled: (error, result) => ({result: error ? {error} : {result}, stop: false})
};
const afterAll = {
  all: returnResults,
  any: throwErrors,
  race: noop,
  allSettled: returnResults
};
const combinator = (pattern) => function(payload, callback) {
  if (!callback)
    return (0, import_effects.cps)(combinators[pattern], payload);
  const results = Array.isArray(payload) ? [] : {};
  const errors = Array.isArray(payload) ? [] : {};
  let count = Object.keys(payload).length;
  if (count === 0) {
    afterAll[pattern](errors, results, callback);
    return noop;
  }
  let stopKey = void 0;
  const cancellations = {};
  const cancelOthers = () => {
    for (let k in cancellations) {
      if (k !== stopKey)
        cancellations[k]();
    }
  };
  for (let k in payload) {
    if (stopKey !== void 0) {
      if ((0, import_conclude.isPromise)(payload[k]))
        payload[k].catch(noop);
      continue;
    }
    cancellations[k] = (0, import_conclude.conclude)(payload[k], (err, res) => {
      const {stop, error, result} = afterOne[pattern](err, res);
      if (stop) {
        stopKey = k;
        cancelOthers();
        if (error)
          callback(Array.isArray(payload) ? error : {[k]: error});
        else
          callback(null, Array.isArray(payload) ? result : {[k]: result});
      } else {
        results[k] = result;
        errors[k] = error;
        if (--count === 0) {
          afterAll[pattern](errors, results, callback);
        }
      }
    });
  }
  return stopKey !== void 0 ? noop : cancelOthers;
};
const combinators = Object.keys(afterOne).reduce((acc, pattern) => Object.assign(acc, {[pattern]: combinator(pattern)}), {});
const {all, any, race, allSettled} = combinators;
