var __defProp = Object.defineProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, {get: all[name], enumerable: true});
};
__markAsModule(exports);
__export(exports, {
  TYPE: () => TYPE,
  call: () => call,
  cps: () => cps,
  cps_no_cancel: () => cps_no_cancel,
  delay: () => delay
});
const TYPE = "@@conclude-effect";
const makeEffect = (type, fn, ...args) => {
  let context = null;
  if (Array.isArray(fn)) {
    [context, fn] = fn;
    if (typeof fn !== "function")
      fn = context[fn];
  }
  return {
    [TYPE]: type,
    context,
    fn,
    args
  };
};
const cps = makeEffect.bind(null, "CPS");
const cps_no_cancel = makeEffect.bind(null, "CPS_NO_CANCEL");
const call = makeEffect.bind(null, "CALL");
function delay(ms, callback) {
  if (!callback)
    return cps(delay, ms);
  const timeout = setTimeout(() => callback(null), ms);
  return () => clearTimeout(timeout);
}
